diff -pru mailman-cvs-2.1-maint/Mailman/Archiver/pipermail.py mailman-2.1.7.cg/Mailman/Archiver/pipermail.py
--- mailman-cvs-2.1-maint/Mailman/Archiver/pipermail.py	2006-01-29 06:12:26.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Archiver/pipermail.py	2005-12-26 02:22:08.000000000 +0100
@@ -224,7 +224,12 @@ class Article:
                 self.headers[i] = message[i]
 
         # Read the message body
-        s = StringIO(message.get_payload(decode=True)\
+        # Check Scrubber-munged paylaod
+        if message.get('x-mailman-scrubbed'):
+            decode = False
+        else:
+            decode = True
+        s = StringIO(message.get_payload(decode=decode)\
                      or message.as_string().split('\n\n',1)[1])
         self.body = s.readlines()
 
diff -pru mailman-cvs-2.1-maint/Mailman/Bouncers/BouncerAPI.py mailman-2.1.7.cg/Mailman/Bouncers/BouncerAPI.py
--- mailman-cvs-2.1-maint/Mailman/Bouncers/BouncerAPI.py	2006-03-01 03:34:10.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/BouncerAPI.py	2005-08-27 03:40:15.000000000 +0200
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998,1999,2000,2001,2002 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,8 +12,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Contains all the common functionality for msg bounce scanning API.
 
@@ -63,7 +62,10 @@ def ScanMessages(mlist, msg):
         modname = 'Mailman.Bouncers.' + module
         __import__(modname)
         addrs = sys.modules[modname].process(msg)
-        if addrs:
-            # Return addrs even if it is Stop. BounceRunner needs this info.
+        if addrs is Stop:
+            # One of the detectors recognized the bounce, but there were no
+            # addresses to extract.  Return the empty list.
+            return []
+        elif addrs:
             return addrs
     return []
diff -pru mailman-cvs-2.1-maint/Mailman/Bouncers/DSN.py mailman-2.1.7.cg/Mailman/Bouncers/DSN.py
--- mailman-cvs-2.1-maint/Mailman/Bouncers/DSN.py	2006-03-01 03:34:10.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/DSN.py	2005-08-27 03:40:15.000000000 +0200
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2003 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,8 +12,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Parse RFC 3464 (i.e. DSN) bounce formats.
 
@@ -53,10 +52,9 @@ def check(msg):
             #
             # Also grok out Action so we can do something with that too.
             action = msgblock.get('action', '').lower()
-            # Some MTAs have been observed that put comments on the action.
-            if action.startswith('delayed'):
+            if action == 'delayed':
                 return Stop
-            if not action.startswith('fail'):
+            if action not in ('failed', 'failure'):
                 # Some non-permanent failure, so ignore this block
                 continue
             params = []
diff -pru mailman-cvs-2.1-maint/Mailman/Bouncers/SimpleMatch.py mailman-2.1.7.cg/Mailman/Bouncers/SimpleMatch.py
--- mailman-cvs-2.1-maint/Mailman/Bouncers/SimpleMatch.py	2006-03-10 11:36:50.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/SimpleMatch.py	2006-02-21 07:21:11.000000000 +0100
@@ -78,31 +78,7 @@ PATTERNS = [
     # Prodigy.net full mailbox
     (_c("User's mailbox is full:"),
      _c('Unable to deliver mail.'),
-     _c("User's mailbox is full:\s*<(?P<addr>[^>]*)>")),
-    # Microsoft SMTPSVC
-    (_c('The email below could not be delivered to the following user:'),
-     _c('Old message:'),
-     _c('<(?P<addr>[^>]*)>')),
-    # Yahoo on behalf of other domains like sbcglobal.net
-    (_c('Unable to deliver message to the following address\(es\)\.'),
-     _c('--- Original message follows\.'),
-     _c('<(?P<addr>[^>]*)>:')),
-    # kundenserver.de
-    (_c('A message that you sent could not be delivered'),
-     _c('^--- The header of the original'),
-     _c('<(?P<addr>[^>]*)>')),
-    # another kundenserver.de
-    (_c('A message that you sent could not be delivered'),
-     _c('^--- The header of the original'),
-     _c('^(?P<addr>[^\s@]+@[^\s@:]+):')),
-    # thehartford.com
-    (_c('Delivery to the following recipients failed'),
-     _c("Bogus - there actually isn't anything"),
-     _c('^\s*(?P<addr>[^\s@]+@[^\s@]+)\s*$')),
-    # and another thehartfod.com/hartfordlife.com
-    (_c('^Your message'),
-     _c('^because:'),
-     _c('^\s*(?P<addr>[^\s@]+@[^\s@]+)\s*$')),
+     _c("User's mailbox is full:\s*<(?P<addr>.*)>.*$")),
     # Next one goes here...
     ]
 
@@ -115,27 +91,19 @@ def process(msg, patterns=None):
     #     0 = nothing seen yet
     #     1 = intro seen
     addrs = {}
-    # MAS: This is a mess. The outer loop used to be over the message
-    # so we only looped through the message once.  Looping through the
-    # message for each set of patterns is obviously way more work, but
-    # if we don't do it, problems arise because scre from the wrong
-    # pattern set matches first and then acre doesn't match.  The
-    # alternative is to split things into separate modules, but then
-    # we process the message multiple times anyway.
-    for scre, ecre, acre in patterns:
-        state = 0
-        for line in email.Iterators.body_line_iterator(msg):
-            if state == 0:
+    state = 0
+    for line in email.Iterators.body_line_iterator(msg):
+        if state == 0:
+            for scre, ecre, acre in patterns:
                 if scre.search(line):
                     state = 1
-            if state == 1:
-                mo = acre.search(line)
-                if mo:
-                    addr = mo.group('addr')
-                    if addr:
-                        addrs[mo.group('addr')] = 1
-                elif ecre.search(line):
                     break
-        if addrs:
-            break
+        if state == 1:
+            mo = acre.search(line)
+            if mo:
+                addr = mo.group('addr')
+                if addr:
+                    addrs[mo.group('addr')] = 1
+            elif ecre.search(line):
+                break
     return addrs.keys()
diff -pru mailman-cvs-2.1-maint/Mailman/Bouncers/SimpleWarning.py mailman-2.1.7.cg/Mailman/Bouncers/SimpleWarning.py
--- mailman-cvs-2.1-maint/Mailman/Bouncers/SimpleWarning.py	2006-03-10 11:36:50.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/SimpleWarning.py	2005-08-27 03:40:15.000000000 +0200
@@ -1,4 +1,4 @@
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001,2002 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,12 +12,10 @@
 # 
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software 
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Recognizes simple heuristically delimited warnings."""
 
-from Mailman.Bouncers.BouncerAPI import Stop
 from Mailman.Bouncers.SimpleMatch import _c
 from Mailman.Bouncers.SimpleMatch import process as _process
 
@@ -43,8 +41,4 @@ patterns = [
 
 
 def process(msg):
-    if _process(msg, patterns):
-        # It's a recognized warning so stop now
-        return Stop
-    else:
-        return []
+    return _process(msg, patterns)
diff -pru mailman-cvs-2.1-maint/Mailman/Bouncers/SMTP32.py mailman-2.1.7.cg/Mailman/Bouncers/SMTP32.py
--- mailman-cvs-2.1-maint/Mailman/Bouncers/SMTP32.py	2006-02-05 20:46:20.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Bouncers/SMTP32.py	2005-08-27 03:40:15.000000000 +0200
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998,1999,2000,2001,2002 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,8 +12,7 @@
 # 
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software 
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Something which claims
 X-Mailer: <SMTP32 vXXXXXX>
@@ -36,8 +35,7 @@ acre = re.compile(r'''
     (                                             # several different prefixes
     user\ mailbox[^:]*:                           # have been spotted in the
     |delivery\ failed[^:]*:                       # wild...
-    |unknown\ user[^:]*:
-    |undeliverable\ +to
+    |undeliverable\ to
     )
     \s*                                           # space separator
     (?P<addr>.*)                                  # and finally, the address
diff -pru mailman-cvs-2.1-maint/Mailman/Cgi/admindb.py mailman-2.1.7.cg/Mailman/Cgi/admindb.py
--- mailman-cvs-2.1-maint/Mailman/Cgi/admindb.py	2005-12-30 19:50:07.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/admindb.py	2006-03-10 16:07:26.000000000 +0100
@@ -81,7 +81,7 @@ def main():
         handle_no_list()
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
diff -pru mailman-cvs-2.1-maint/Mailman/Cgi/admin.py mailman-2.1.7.cg/Mailman/Cgi/admin.py
--- mailman-cvs-2.1-maint/Mailman/Cgi/admin.py	2005-12-30 19:50:07.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/admin.py	2006-03-10 16:07:19.000000000 +0100
@@ -65,8 +65,9 @@ def main():
         # None, so just do the admin overview and be done with it
         admin_overview()
         return
+
     # Get the list object
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
@@ -418,7 +419,7 @@ def show_results(mlist, doc, category, s
                        '<br>&nbsp;<br>')
     # We do not allow through-the-web deletion of the site list!
     if mm_cfg.OWNERS_CAN_DELETE_THEIR_OWN_LISTS and \
-           mlist.internal_name() <> mm_cfg.MAILMAN_SITE_LIST:
+           mlist.local_name <> mm_cfg.MAILMAN_SITE_LIST:
         otherlinks.AddItem(Link(mlist.GetScriptURL('rmlist'),
                                 _('Delete this mailing list')).Format() +
                            _(' (requires confirmation)<br>&nbsp;<br>'))
diff -pru mailman-cvs-2.1-maint/Mailman/Cgi/confirm.py mailman-2.1.7.cg/Mailman/Cgi/confirm.py
--- mailman-cvs-2.1-maint/Mailman/Cgi/confirm.py	2005-12-30 19:50:07.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/confirm.py	2006-03-10 16:07:37.000000000 +0100
@@ -53,7 +53,7 @@ def main():
         print doc.Format()
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
diff -pru mailman-cvs-2.1-maint/Mailman/Cgi/edithtml.py mailman-2.1.7.cg/Mailman/Cgi/edithtml.py
--- mailman-cvs-2.1-maint/Mailman/Cgi/edithtml.py	2006-01-09 08:06:52.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/edithtml.py	2006-03-10 16:07:53.000000000 +0100
@@ -61,7 +61,7 @@ def main():
         print doc.Format()
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
diff -pru mailman-cvs-2.1-maint/Mailman/Cgi/listinfo.py mailman-2.1.7.cg/Mailman/Cgi/listinfo.py
--- mailman-cvs-2.1-maint/Mailman/Cgi/listinfo.py	2005-08-27 03:40:15.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Cgi/listinfo.py	2006-03-10 16:08:07.000000000 +0100
@@ -42,7 +42,7 @@ def main():
         listinfo_overview()
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
diff -pru mailman-cvs-2.1-maint/Mailman/Cgi/options.py mailman-2.1.7.cg/Mailman/Cgi/options.py
--- mailman-cvs-2.1-maint/Mailman/Cgi/options.py	2005-12-03 02:07:13.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/options.py	2006-03-10 16:08:20.000000000 +0100
@@ -65,7 +65,7 @@ def main():
         return
 
     # get the list and user's name
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     # open list
     try:
         mlist = MailList.MailList(listname, lock=0)
diff -pru mailman-cvs-2.1-maint/Mailman/Cgi/private.py mailman-2.1.7.cg/Mailman/Cgi/private.py
--- mailman-cvs-2.1-maint/Mailman/Cgi/private.py	2005-12-30 19:50:07.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Cgi/private.py	2006-04-16 02:20:50.000000000 +0200
@@ -29,6 +29,7 @@ from Mailman import Errors
 from Mailman import i18n
 from Mailman.htmlformat import *
 from Mailman.Logging.Syslog import syslog
+from Mailman.Site import get_mboxpath
 
 # Set up i18n.  Until we know which list is being requested, we use the
 # server's default.
@@ -79,7 +80,7 @@ def main():
     true_filename = os.path.join(
         mm_cfg.PRIVATE_ARCHIVE_FILE_DIR, tpath)
 
-    listname = parts[0].lower()
+    listname = parts[0].lower() # NDIM XXX use Utils.GetListname
     mboxfile = ''
     if len(parts) > 1:
         mboxfile = parts[1]
@@ -166,8 +167,7 @@ def main():
         if ctype is None:
             ctype = 'text/html'
         if mboxfile:
-            f = open(os.path.join(mlist.archive_dir() + '.mbox',
-                                  mlist.internal_name() + '.mbox'))
+            f = open(get_mboxpath(mlist.internal_name()))
             ctype = 'text/plain'
         elif true_filename.endswith('.gz'):
             import gzip
diff -pru mailman-cvs-2.1-maint/Mailman/Cgi/rmlist.py mailman-2.1.7.cg/Mailman/Cgi/rmlist.py
--- mailman-cvs-2.1-maint/Mailman/Cgi/rmlist.py	2005-08-27 03:40:15.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Cgi/rmlist.py	2006-03-10 16:09:01.000000000 +0100
@@ -55,7 +55,7 @@ def main():
         syslog('error', 'Bad URL specification: %s', parts)
         return
         
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
@@ -136,8 +136,9 @@ def process_request(doc, cgidata, mlist)
 
     problems = 0
     listname = mlist.internal_name()
+    local_part = mlist.local_part
     for dirtmpl in REMOVABLES:
-        dir = os.path.join(mm_cfg.VAR_PREFIX, dirtmpl % listname)
+        dir = os.path.join(mm_cfg.VAR_PREFIX, dirtmpl % local_part) # NDIM XXX
         if os.path.islink(dir):
             try:
                 os.unlink(dir)
diff -pru mailman-cvs-2.1-maint/Mailman/Cgi/roster.py mailman-2.1.7.cg/Mailman/Cgi/roster.py
--- mailman-cvs-2.1-maint/Mailman/Cgi/roster.py	2005-08-27 03:40:15.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Cgi/roster.py	2006-03-10 16:09:10.000000000 +0100
@@ -48,7 +48,7 @@ def main():
         error_page(_('Invalid options to CGI script'))
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
diff -pru mailman-cvs-2.1-maint/Mailman/Cgi/subscribe.py mailman-2.1.7.cg/Mailman/Cgi/subscribe.py
--- mailman-cvs-2.1-maint/Mailman/Cgi/subscribe.py	2005-08-27 03:40:15.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Cgi/subscribe.py	2006-03-10 16:09:20.000000000 +0100
@@ -51,7 +51,7 @@ def main():
         print doc.Format()
         return
 
-    listname = parts[0].lower()
+    listname = Utils.GetListName(parts)
     try:
         mlist = MailList.MailList(listname, lock=0)
     except Errors.MMListError, e:
diff -pru mailman-cvs-2.1-maint/Mailman/Defaults.py.in mailman-2.1.7.cg/Mailman/Defaults.py.in
--- mailman-cvs-2.1-maint/Mailman/Defaults.py.in	2006-01-15 22:01:35.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Defaults.py.in	2006-03-04 18:29:11.000000000 +0100
@@ -1,6 +1,6 @@
 # -*- python -*-
 
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -476,7 +476,6 @@ GLOBAL_PIPELINE = [
     'CalcRecips',
     'AvoidDuplicates',
     'Cleanse',
-    'CleanseDKIM',
     'CookHeaders',
     # And now we send the message to the digest mbox file, and to the arch and
     # news queues.  Runners will provide further processing of the message,
@@ -495,7 +494,6 @@ GLOBAL_PIPELINE = [
 OWNER_PIPELINE = [
     'SpamDetect',
     'Replybot',
-    'CleanseDKIM',
     'OwnerRecips',
     'ToOutgoing',
     ]
@@ -830,7 +828,7 @@ DEFAULT_MSG_HEADER = ""
 DEFAULT_MSG_FOOTER = """_______________________________________________
 %(real_name)s mailing list
 %(real_name)s@%(host_name)s
-%(web_page_url)slistinfo%(cgiext)s/%(_internal_name)s
+%(web_page_url)slistinfo%(cgiext)s/%(local_part)s
 """
 
 # Where to put subject prefix for 'Re:' messages:
diff -pru mailman-cvs-2.1-maint/Mailman/Deliverer.py mailman-2.1.7.cg/Mailman/Deliverer.py
--- mailman-cvs-2.1-maint/Mailman/Deliverer.py	2005-12-30 19:50:07.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Deliverer.py	2006-03-04 12:31:03.000000000 +0100
@@ -158,9 +158,8 @@ your membership administrative address, 
         # Some one was invited to one list but tried to confirm to a different
         # list.  We inform both list owners of the bogosity, but be careful
         # not to reveal too much information.
-        selfname = self.internal_name()
         syslog('mischief', '%s was invited to %s but confirmed to %s',
-               address, listname, selfname)
+               address, listname, self.internal_name())
         # First send a notice to the attacked list
         msg = Message.OwnerNotification(
             self,
@@ -207,7 +206,7 @@ is required.""")))
         # probe message.
         token = self.pend_new(Pending.PROBE_BOUNCE, member, msg)
         probedict = {
-            'bounces': self.internal_name() + '-bounces',
+            'bounces': self.getListAddress('bounces'),
             'token': token,
             }
         probeaddr = '%s@%s' % ((mm_cfg.VERP_PROBE_FORMAT % probedict),
diff -pru mailman-cvs-2.1-maint/Mailman/Gui/Digest.py mailman-2.1.7.cg/Mailman/Gui/Digest.py
--- mailman-cvs-2.1-maint/Mailman/Gui/Digest.py	2005-08-27 03:40:15.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Gui/Digest.py	2006-03-04 18:41:06.000000000 +0100
@@ -25,8 +25,9 @@ from Mailman.Gui.GUIBase import GUIBase
 
 # Common b/w nondigest and digest headers & footers.  Personalizations may add
 # to this.
+# NDIM XXX remove _internal_name?
 ALLOWEDS = ('real_name', 'list_name', 'host_name', 'web_page_url',
-            'description', 'info', 'cgiext', '_internal_name',
+            'description', 'info', 'cgiext', '_internal_name', 'local_part',
             )
 
 
diff -pru mailman-cvs-2.1-maint/Mailman/Gui/General.py mailman-2.1.7.cg/Mailman/Gui/General.py
--- mailman-cvs-2.1-maint/Mailman/Gui/General.py	2005-10-23 10:10:22.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Gui/General.py	2006-02-21 07:44:48.000000000 +0100
@@ -419,7 +419,7 @@ class General(GUIBase):
 
     def _setValue(self, mlist, property, val, doc):
         if property == 'real_name' and \
-               val.lower() <> mlist.internal_name().lower():
+               val.lower() <> mlist.real_name.lower():
             # These values can't differ by other than case
             doc.addError(_("""<b>real_name</b> attribute not
             changed!  It must differ from the list's name by case
diff -pru mailman-cvs-2.1-maint/Mailman/Gui/Topics.py mailman-2.1.7.cg/Mailman/Gui/Topics.py
--- mailman-cvs-2.1-maint/Mailman/Gui/Topics.py	2006-01-15 00:56:58.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Gui/Topics.py	2006-02-21 07:21:11.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001-2003 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,8 +12,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 import re
 
diff -pru mailman-cvs-2.1-maint/Mailman/Handlers/Cleanse.py mailman-2.1.7.cg/Mailman/Handlers/Cleanse.py
--- mailman-cvs-2.1-maint/Mailman/Handlers/Cleanse.py	2006-01-15 22:00:51.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/Cleanse.py	2005-12-30 19:50:08.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -50,3 +50,12 @@ def process(mlist, msg, msgdata):
     del msg['x-confirm-reading-to']
     # Pegasus mail uses this one... sigh
     del msg['x-pmrqc']
+    # Remove any "DomainKeys" (or similar) header lines.  The values contained
+    # in these header lines are intended to be used by the recipient to detect
+    # forgery or tampering in transit, and the modifications made by Mailman
+    # to the headers and body of the message will cause these keys to appear
+    # invalid.  Removing them will at least avoid this misleading result, and
+    # it will also give the MTA the opportunity to regenerate valid keys
+    # originating at the Mailman server for the outgoing message.
+    del msg['domainkey-signature']
+    del msg['dkim-signature']
diff -pru mailman-cvs-2.1-maint/Mailman/Handlers/CookHeaders.py mailman-2.1.7.cg/Mailman/Handlers/CookHeaders.py
--- mailman-cvs-2.1-maint/Mailman/Handlers/CookHeaders.py	2006-02-17 03:42:35.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/CookHeaders.py	2006-03-04 08:59:18.000000000 +0100
@@ -180,7 +180,7 @@ def process(mlist, msg, msgdata):
     if msgdata.get('_nolist') or not mlist.include_rfc2369_headers:
         return
     # This will act like an email address for purposes of formataddr()
-    listid = '%s.%s' % (mlist.internal_name(), mlist.host_name)
+    listid = '%s.%s' % (mlist.local_part, mlist.host_name)
     cset = Utils.GetCharSet(mlist.preferred_language)
     if mlist.description:
         # Don't wrap the header since here we just want to get it properly RFC
@@ -327,16 +327,20 @@ def prefix_subject(mlist, msg, msgdata):
 
 
 
-def ch_oneline(headerstr):
+def ch_oneline(s):
     # Decode header string in one line and convert into single charset
     # copied and modified from ToDigest.py and Utils.py
     # return (string, cset) tuple as check for failure
     try:
-        d = decode_header(headerstr)
+        d = decode_header(s)
         # at this point, we should rstrip() every string because some
         # MUA deliberately add trailing spaces when composing return
         # message.
-        d = [(s.rstrip(), c) for (s,c) in d]
+        i = 0
+        for (s,c) in d:
+            s = s.rstrip()
+            d[i] = (s,c)
+            i += 1
         cset = 'us-ascii'
         for x in d:
             # search for no-None charset
@@ -349,4 +353,4 @@ def ch_oneline(headerstr):
         return oneline.encode(cset, 'replace'), cset
     except (LookupError, UnicodeError, ValueError, HeaderParseError):
         # possibly charset problem. return with undecoded string in one line.
-        return ''.join(headerstr.splitlines()), 'us-ascii'
+        return ''.join(s.splitlines()), 'us-ascii'
diff -pru mailman-cvs-2.1-maint/Mailman/Handlers/Decorate.py mailman-2.1.7.cg/Mailman/Handlers/Decorate.py
--- mailman-cvs-2.1-maint/Mailman/Handlers/Decorate.py	2006-01-29 06:12:26.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/Decorate.py	2006-03-04 18:54:25.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -98,7 +98,12 @@ def process(mlist, msg, msgdata):
         uheader = unicode(header, lcset)
         ufooter = unicode(footer, lcset)
         try:
-            oldpayload = unicode(msg.get_payload(decode=True), mcset)
+            # First, check if the message was Scrubber-munged
+            if msg.get('x-mailman-scrubbed'):
+                decode = False
+            else:
+                decode = True
+            oldpayload = unicode(msg.get_payload(decode=decode), mcset)
             frontsep = endsep = u''
             if header and not header.endswith('\n'):
                 frontsep = u'\n'
@@ -193,12 +198,12 @@ def decorate(mlist, template, what, extr
     # example, a footer of "% silly %(real_name)s" would give a header
     # containing all list attributes.  While we've previously removed such
     # really bad ones like `password' and `passwords', it's much better to
-    # provide a whitelist of known good attributes, then to try to remove a
+    # provide a whitelist of known good attributes, than to try to remove a
     # blacklist of known bad ones.
     d = SafeDict({'real_name'     : mlist.real_name,
-                  'list_name'     : mlist.internal_name(),
+                  'list_name'     : mlist.local_part,
                   # For backwards compatibility
-                  '_internal_name': mlist.internal_name(),
+                  '_internal_name': mlist.local_part,
                   'host_name'     : mlist.host_name,
                   'web_page_url'  : mlist.web_page_url,
                   'description'   : mlist.description,
diff -pru mailman-cvs-2.1-maint/Mailman/Handlers/Hold.py mailman-2.1.7.cg/Mailman/Handlers/Hold.py
--- mailman-cvs-2.1-maint/Mailman/Handlers/Hold.py	2005-09-19 05:08:57.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Handlers/Hold.py	2006-03-04 18:51:57.000000000 +0100
@@ -129,12 +129,13 @@ def process(mlist, msg, msgdata):
         return
     # Get the sender of the message
     listname = mlist.internal_name()
-    adminaddr = listname + '-admin'
+    adminaddr = mlist.getListAddress('admin')
     sender = msg.get_sender()
     # Special case an ugly sendmail feature: If there exists an alias of the
     # form "owner-foo: bar" and sendmail receives mail for address "foo",
     # sendmail will change the envelope sender of the message to "bar" before
     # delivering.  This feature does not appear to be configurable.  *Boggle*.
+    # NDIM XXX Handle listname == 'foo@blah.com'
     if not sender or sender[:len(listname)+6] == adminaddr:
         sender = msg.get_sender(use_envelope=0)
     #
diff -pru mailman-cvs-2.1-maint/Mailman/Handlers/Scrubber.py mailman-2.1.7.cg/Mailman/Handlers/Scrubber.py
--- mailman-cvs-2.1-maint/Mailman/Handlers/Scrubber.py	2006-02-19 22:03:38.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/Scrubber.py	2005-12-30 19:50:08.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -111,9 +111,9 @@ class ScrubberGenerator(Generator):
             Generator._write_headers(self, msg)
 
 
-def safe_strftime(fmt, t):
+def safe_strftime(fmt, floatsecs):
     try:
-        return time.strftime(fmt, t)
+        return time.strftime(fmt, floatsecs)
     except (TypeError, ValueError, OverflowError):
         return None
 
@@ -164,10 +164,12 @@ def calculate_attachments_dir(mlist, msg
 
 def replace_payload_by_text(msg, text, charset):
     # TK: This is a common function in replacing the attachment and the main
-    # message by a text (scrubbing).
+    # message by a text (scrubbing).  Also, add a flag indicating it has been
+    # scrubbed.
     del msg['content-type']
     del msg['content-transfer-encoding']
     msg.set_payload(text, charset)
+    msg['X-Mailman-Scrubbed'] = 'Yes'
 
 
 
@@ -342,13 +344,13 @@ Url : %(url)s
                 text.append(_('Skipped content of type %(partctype)s\n'))
                 continue
             try:
-                t = part.get_payload(decode=True)
-            # MAS: TypeError exception can occur if payload is None. This
-            # was observed with a message that contained an attached
-            # message/delivery-status part. Because of the special parsing
-            # of this type, this resulted in a text/plain sub-part with a
-            # null body. See bug 1430236.
-            except (binascii.Error, TypeError):
+                # Check if the part is replaced.
+                if part.get('x-mailman-scrubbed'):
+                    decode = False
+                else:
+                    decode = True
+                t = part.get_payload(decode=decode)
+            except binascii.Error:
                 t = part.get_payload()
             # TK: get_content_charset() returns 'iso-2022-jp' for internally
             # crafted (scrubbed) 'euc-jp' text part. So, first try
diff -pru mailman-cvs-2.1-maint/Mailman/Handlers/SMTPDirect.py mailman-2.1.7.cg/Mailman/Handlers/SMTPDirect.py
--- mailman-cvs-2.1-maint/Mailman/Handlers/SMTPDirect.py	2005-12-30 19:50:08.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Handlers/SMTPDirect.py	2006-03-04 18:54:50.000000000 +0100
@@ -175,7 +175,7 @@ def process(mlist, msg, msgdata):
                           'size'    : len(msg.as_string()),
                           '#recips' : len(recips),
                           '#refused': len(refused),
-                          'listname': mlist.internal_name(),
+                          'listname': mlist.local_part,
                           'sender'  : origsender,
                           })
     # We have to use the copy() method because extended call syntax requires a
